/*
select FF.M1, TT.M2
from
   (select min(DISTANCE) M1 from FEATURE) FF,
   (select min(REFPO_DIST1) M2 from TMPREF) TT
where M1<M2;

select FF.M1, TT.M2
from
   (select max(DISTANCE) M1 from FEATURE) FF,
   (select max(REFPO_DIST2) M2 from TMPREF) TT
where M1>M2;

select F.DISTANCE, F.G_DISTANCE, F.CUCH, U.SYSKEY, T.CUCH1, T.CUCH2
from UCHASTOK U, FEATURE F, TMPREF T, INSPECTUCH I
where (F.DISTANCE between T.REFPO_DIST1 and T.REFPO_DIST2) and T.CUCH1=T.CUCH2
and T.CUCH1=U.SYSKEY
and I.CUCH=U.SYSKEY and I.CINSPECT=F.CINSPECT;

select F.DISTANCE, F.G_DISTANCE, F.CUCH, U.SYSKEY, T.CUCH1, T.CUCH2
from UCHASTOK U, FEATURE F, TMPREF T, INSPECTUCH I
where (F.DISTANCE between T.REFPO_DIST1 and T.REFPO_DIST2) and T.CUCH1<>T.CUCH2
and (F.G_DISTANCE between U.MBEG and U.MEND)
and I.CUCH=U.SYSKEY and I.CINSPECT=F.CINSPECT;

select F.CUCH, F.DISTANCE
from FEATURE F, UCHASTOK U, TMPREF T, INSPECTUCH I
   where T.CUCH1=U.SYSKEY and I.CUCH=U.SYSKEY and T.CUCH1=T.CUCH2
   and (F.DISTANCE between T.REFPO_DIST1 and T.REFPO_DIST2) and I.CINSPECT=F.CINSPECT;

create table FEATURE as select * from SK_FEATURE S where S.CINSPECT=500000001;

drop table TMPREF;
create table TMPREF
   (
   CREF1 number(12),
   DESCR varchar2(50),
   CUCH1 number(12),
   CUCH2 number(12),
   REFPO_DIST1 number(12),
   G_DIST1 number(12),
   CREF2 number(12),
   REFPO_DIST2 number(12),
   G_DIST2 number(12),
   KOEFF float
   );
*/

-- *********************************************************************************************************************
--  FEATURE.G_DISTANCE   , , FEATURE.CUCH 
-- (      CINSPECT=500000001  7039 )
-- *********************************************************************************************************************
select to_char(sysdate, 'dd.mm.yyyy hh24:mi:ss') BEG_TIME from dual;

-- 1.   TMPREF.KOEFF
--update TMPREF T
--set T.KOEFF = (select (T.REFPO_DIST2-T.REFPO_DIST1)/(T.G_DIST2-T.G_DIST1) Q from TMPREF T);

-- 2.  FEATURE.G_DISTANCE (    1 TMPREF.KOEFF)
--     (   FEATURE.CUCH ?)
-- )  FEATURE.DISTANCE    TMPREF.REFPO_DIST1  TMPREF.REFPO_DIST2:
--     (  ,   NULL,    2  2)
update FEATURE F set F.G_DISTANCE =
   (select 
      T.KOEFF*(F.DISTANCE-T.REFPO_DIST1)+T.G_DIST1 GD from TMPREF T
   where
       F.DISTANCE between T.REFPO_DIST1 and T.REFPO_DIST2);
-- )  FEATURE.DISTANCE  TMPREF.REFPO_DIST1:
update FEATURE F set F.G_DISTANCE =
   (select T.KOEFF*(F.DISTANCE-T.REFPO_DIST1)+T.G_DIST1 GD from TMPREF T)
where
    F.DISTANCE < (select min(T.REFPO_DIST1)  from TMPREF T);
-- )  FEATURE.DISTANCE  TMPREF.REFPO_DIST2:
update FEATURE F set F.G_DISTANCE =
   (select T.KOEFF*(F.DISTANCE-T.REFPO_DIST1)+T.G_DIST1 GD from TMPREF T)
where
    F.DISTANCE > (select max(T.REFPO_DIST2)  from TMPREF T);

-- 3.  FEATURE.CUCH (    2 FEATURE.G_DISTANCE)
-- 1)      (  2-2):
-- )  FEATURE.DISTANCE    TMPREF.REFPO_DIST1  TMPREF.REFPO_DIST2:
--     (  ,   NULL,    3.1  3.1)
update FEATURE F set F.CUCH =
   (select U.SYSKEY from UCHASTOK U, TMPREF T, INSPECTUCH I
   where U.SYSKEY=T.CUCH1 and U.SYSKEY=I.CUCH and T.CUCH1=T.CUCH2
   and F.DISTANCE between T.REFPO_DIST1 and T.REFPO_DIST2
   and F.CINSPECT=I.CINSPECT);
-- )  FEATURE.DISTANCE  TMPREF.REFPO_DIST1:
update FEATURE F set F.CUCH =
   (select U.SYSKEY from UCHASTOK U, TMPREF T, INSPECTUCH I
   where U.SYSKEY=T.CUCH1 and U.SYSKEY=I.CUCH and T.CUCH1=T.CUCH2
   and F.CINSPECT=I.CINSPECT)
where
    F.DISTANCE < (select min(T.REFPO_DIST1)  from TMPREF T);
-- )  FEATURE.DISTANCE  TMPREF.REFPO_DIST2:
update FEATURE F set F.CUCH =
   (select U.SYSKEY from UCHASTOK U, TMPREF T, INSPECTUCH I
   where U.SYSKEY=T.CUCH1 and U.SYSKEY=I.CUCH and T.CUCH1=T.CUCH2
   and F.CINSPECT=I.CINSPECT)
where
    F.DISTANCE > (select max(T.REFPO_DIST2)  from TMPREF T);
-- 2)      (  2-2:
-- )  FEATURE.DISTANCE    TMPREF.REFPO_DIST1  TMPREF.REFPO_DIST2:
--     (  ,   NULL,    3.2  3.2)
update FEATURE F set F.CUCH =
   (select U.SYSKEY from UCHASTOK U where F.G_DISTANCE between U.MBEG and U.MEND)
where
    F.CINSPECT =
    (select I.CINSPECT from INSPECTUCH I, UCHASTOK U, TMPREF T
    where I.CUCH=U.SYSKEY and T.CUCH1<>T.CUCH2
    and (F.DISTANCE between T.REFPO_DIST1 and T.REFPO_DIST2));
-- )  FEATURE.DISTANCE  TMPREF.REFPO_DIST1:
update FEATURE F set F.CUCH =
   (select U.SYSKEY from UCHASTOK U where F.G_DISTANCE between U.MBEG and U.MEND)
where
    F.CINSPECT =
    (select I.CINSPECT from INSPECTUCH I, UCHASTOK U, TMPREF T
    where I.CUCH=U.SYSKEY and T.CUCH1<>T.CUCH2
    and F.DISTANCE < (select min(T.REFPO_DIST1) from TMPREF T));
-- )  FEATURE.DISTANCE  TMPREF.REFPO_DIST2:
update FEATURE F set F.CUCH =
   (select U.SYSKEY from UCHASTOK U where F.G_DISTANCE between U.MBEG and U.MEND)
where
    F.CINSPECT =
    (select I.CINSPECT from INSPECTUCH I, UCHASTOK U, TMPREF T
    where I.CUCH=U.SYSKEY and T.CUCH1<>T.CUCH2
    and F.DISTANCE > (select max(T.REFPO_DIST2)  from TMPREF T));


select to_char(sysdate, 'dd.mm.yyyy hh24:mi:ss') END_TIME from dual;
-- *********************************************************************************************************************



